#include "ax.h"

axWindowDBE::axWindowDBE(char *name = "axWindowDBE",
	int width = 256, int height = 256)
	: axWindow(name, width, height)
{
}

void axWindowDBE::init()
{
	int n, i;

	axWindow::init();
	XdbeQueryExtension(display_, &n, &i);
	if(n == 0 && i == 0)
		panic("axWindowDBE: double buffer extension not supported!");
	back_ = XdbeAllocateBackBufferName(display_, window_, XdbeBackground);
	drawable_ = &back_; // reroute all X wrappers to the back-window
}

void axWindowDBE::swapBuffers()
{
	XdbeSwapInfo dsi;
	dsi.swap_action = XdbeBackground;
	dsi.swap_window = window_;
	XdbeSwapBuffers(display_, &dsi, 1);
}
