#include "ax.h"

class Ex1 : public axWindow{
	public:
	Ex1() : axWindow("ex1", 256, 256) { }

	void onExpose(XEvent &ev){
		//axWindow::onExpose(ev); // call superclass
		int x1 = ev.xexpose.x;
		int y1 = ev.xexpose.y;
		int x2 = x1 + ev.xexpose.width;
		int y2 = y1 + ev.xexpose.height;
		int size = 4;
		char msg[100];
		sprintf(msg, "Ex1::expose: (%d, %d, %d, %d)", x1, y1, x2, y2);
		log(msg);
		for(int x = x1; x < x2; x += size)
			for(int y = y1; y < y2; y += size){
				setForeground((x << 16) + (0x80 << 8) + y);
				fillRectangle(x, y, size, size);
			}
		setForeground(0);
		drawLine(x1, y1, x2, y2);
		drawLine(x1, y2, x2, y1);
	}
};

void exception_test()
{
	axVector<int> ivec;

	for(int i = 0; i < 10; i++)
		ivec.add(new int(i * i));

	// goes out of range on purpose
	for(int i = 0; i <= ivec.size(); i++)
		printf("ivec[%d] = %d\n", i, ivec[i]);
}

int main(int argc, char **argv)
{
	Ex1 e;
	try{
		e.trace(true);
		e.run();
		//exception_test();
	}
	catch(axException e){
		cout << e;
	}
}
